<template>
  <div>
    <br />
    <v-card>
      <div class="d-block pa-2 green accent-5 white--text">
        <v-icon color="white" class="ma-1 ms-2"
          >mdi-format-list-bulleted</v-icon
        >
        Assignment of Open Work Orders
      </div>
      <br />
      <v-col>
        <v-row>
          <v-btn
            rounded
            color="#c6f0ca"
            small
            class="ma-2 ms-2"
            @click="ListAll()"
            ><v-icon small>mdi-format-list-bulleted</v-icon>List
          </v-btn>
          <v-menu
            ref="menu"
            v-model="menu"
            :close-on-content-click="false"
            :return-value.sync="date"
            transition="scale-transition"
            offset-y
            min-width="auto"
          >
            <template v-slot:activator="{ on, attrs }">
              <v-text-field
                v-model="date"
                label="Picker in menu"
                prepend-icon="mdi-calendar"
                readonly
                v-bind="attrs"
                v-on="on"
                class="ma-0"
              ></v-text-field>
              <v-dialog v-model="dialog3">
                <v-card height="520">
                  <v-card-title class="ms-15 ">
                    <div id="chart" class="ms-15 ma-3">
                      <apexchart
                        type="line"
                        width="700"
                        height="380"
                        :options="chartOptions"
                        :series="series"
                        class="ms-15"
                      ></apexchart>
                    </div>
                  </v-card-title>
                  <v-card-actions>
                    <v-btn color="primary" text @click="dialog3 = false">
                      Close
                    </v-btn>
                  </v-card-actions>
                </v-card>
              </v-dialog>
            </template>
            <v-date-picker v-model="date" no-title scrollable>
              <v-spacer></v-spacer>
              <v-btn text color="primary" @click="menu = false">
                Cancel
              </v-btn>
              <v-btn text color="primary" @click="ListFill(date)">
                OK
              </v-btn>
            </v-date-picker>
          </v-menu>
          <v-spacer></v-spacer>
        </v-row>
      </v-col>
      <br />
      <v-col>
        <v-row>
          <v-toolbar-title class="ms-4">List Table</v-toolbar-title>
          <v-spacer></v-spacer>
          <v-btn class="ma-2" color="#c6f0ca" @click="dialog3 = !dialog3">
            <v-icon>mdi-chart-timeline-variant</v-icon>_Charts
          </v-btn>
        </v-row>
        <v-spacer></v-spacer>
        <v-data-table
          :headers="headers"
          :items="items"
          item-key="id"
        ></v-data-table>
      </v-col>
    </v-card>
  </div>
</template>

<script>
import axios from "axios";
import moment from "moment";
import VueApexCharts from "vue-apexcharts";

export default {
  components: {
    apexchart: VueApexCharts,
  },
  name: "HelloWorld",
  data: () => ({
    menu: false,
    modal: false,
    dialog3: false,
    items: [],
    date: "",

    headers: [
      { text: "ID", sortable: true, value: "id" },
      { text: "Data 1 ", sortable: false, value: "data" },
      { text: "Timestamp", sortable: false, value: "timestamp" },
      { text: "Data 2", sortable: false, value: "data2" },
    ],

    series: [
      {
        name: "จำนวน",
        data: [],
      },
    ],
    chartOptions: {
      chart: {
        height: 350,
        type: "line",
        zoom: {
          enabled: false,
        },
      },
      dataLabels: {
        enabled: false,
      },
      stroke: {
        curve: "straight",
      },
      title: {
        text: "จำนวน sensor ในแต่ละวัน",
        align: "center",
      },
      grid: {
        row: {
          colors: ["#f3f3f3", "transparent"],
          opacity: 0.5,
        },
      },
      xaxis: {
        categories: [],
      },
    },
  }),

  methods: {
    async ListAll() {
      let res = await axios.get(`https://swdapi.ddns.net:8090/data/ttntest`);
      this.items = res.data;
      for (let e of this.items) {
        e.timestamp = moment(e.timestamp).format("DD/MM/YYYY");
        // console.log(this.items);
      }
      const counts = {};
      this.items.forEach((e) => {
        counts[e["timestamp"]] = (counts[e["timestamp"]] || 0) + 1;
      });

      let arr = [];
      let key = [];
      for (let property in counts) {
        arr.push(counts[property]);
        key.push(property);
      }
      console.log("key :>> ", key);

      console.log(arr);
      this.chartOptions.xaxis.categories = key;
      this.series[0].data = arr;
      console.log(this.series);
    },
    ListFill(date) {
      // console.log("d5", date);
      this.$refs.menu.save(date);
      const filldate = moment(date).format("DD/MM/YYYY");
      console.log(filldate, "car");
      this.items = this.items.filter(
        (e) => moment(e.timestamp).format("L") === filldate
      );
      for (let e of this.items) {
        e.timestamp = moment(e.timestamp).format("L");
      }
    },
  },
  async created() {
    await this.ListAll();
  },
};
</script>
